"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  compatLowVersion: () => compatLowVersion,
  externalsExtension: () => externalsExtension
});
module.exports = __toCommonJS(src_exports);
var externalRE = /^(https?:)?\/\//;
var isExternalUrl = (url) => externalRE.test(url);
var exclude = [];
var tempOptions = {};
function externalsExtensionResolverConfigFilter() {
  return {
    name: "vite-plugin-externals-extension-config-filter",
    enforce: "post" /* POST */,
    async config(config) {
      var _a, _b;
      const include = (_b = (_a = config.optimizeDeps) == null ? void 0 : _a.include) != null ? _b : [];
      include == null ? void 0 : include.forEach((url, index) => {
        if (exclude.includes(url)) {
          include.splice(index, 1);
        }
      });
    }
  };
}
async function getExcludeUrls(options) {
  if (exclude.length) {
    return exclude;
  }
  exclude.push(
    ...await Promise.all(
      Object.entries(options).filter((option) => !option[1].getter).map(async (option) => {
        option[1].url = typeof option[1].url === "function" ? await option[1].url() : option[1].url;
        return option[1].url;
      })
    )
  );
  return exclude;
}
function externalsExtensionResolver(options) {
  tempOptions = options;
  return {
    name: "vite-plugin-externals-extension",
    enforce: "pre" /* PRE */,
    async resolveId(id) {
      if (options[id] && !!options[id].getter) {
        return id;
      } else if (options[id]) {
        return options[id].url;
      }
      return null;
    },
    async config() {
      return {
        build: {
          rollupOptions: {
            external: await getExcludeUrls(tempOptions)
          }
        }
      };
    },
    async transformIndexHtml() {
      return Object.entries(options).filter((option) => !!option[1].getter).map((option) => option[1].url).filter(isExternalUrl).map((url) => ({
        tag: "script",
        attrs: {
          src: url
        }
      }));
    },
    async load(id) {
      if (options[id]) {
        const { getter } = options[id] || {};
        if (typeof getter === "function") {
          return `
            const getter = ${getter};
            const fetchGetterModule = getter(window);
            export default fetchGetterModule;
          `;
        }
        return `
          export default window['${getter}']
        `;
      }
      return null;
    }
  };
}
async function compatLowVersion() {
  return await getExcludeUrls(tempOptions);
}
function externalsExtension(options) {
  return [externalsExtensionResolver(options), externalsExtensionResolverConfigFilter()];
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  compatLowVersion,
  externalsExtension
});
//# sourceMappingURL=index.js.map